<?php // bibliothèque de Modèles HTML Basiques ©PCo-fév2007

// Charge un fichier modèle HTML
function htmlCharger($unNomFichierHTML) {
  $html=file_get_contents($unNomFichierHTML);
  // [!] Pour conserver les caractères " et ', 
  // utiliser leurs entités numériques :&#34; et &#39; 
  $html=str_replace("\"", "'", $html);
  $html=str_replace("\\'", "\\\"", $html);
  return $html;
}

// Extrait le code HTML du modèle compris entre le marqueur transmis
// et un suivant.
// 2 cas particuliers :
// - si le marqueur est vide, c'est le début du code jusqu'au premier marqueur
// - si c'est le dernier marqueur, c'est du marqueur jusqu'à la fin
function htmlExtraire($unHTML, $unMarqueur="") {
  if ($unMarqueur=="") {
    $blocs=explode("<!--m:", $unHTML);
    $ret=$blocs[0];
  }
  else {
    $pat="#\<\!--m:$unMarqueur--\>(.*)\<\!--m:.*--\>#isU";
    if (preg_match($pat, $unHTML, $bloc)) {
      $ret=$bloc[1];
    }
    else {
      $pos=strpos($unHTML, "<!--m:$unMarqueur");
      if ($pos === FALSE) {
        $ret="[!] _htmlModele.inc.php : Marqueur <b>'$unMarqueur'</b> inconnu<br />";
      }   
      else {
        $ret=substr($unHTML, $pos+strlen($unMarqueur)+11);      
      }
   }
  }
  return $ret;
}

// associée à eval, 
// affiche le code HTML avec subtitution des variables PHP par leur valeur
function htmlEcho($unHTML, $unMarqueur="") {
  $ret=htmlExtraire($unHTML, $unMarqueur);
  //return "echo \"$ret\n\";";
  return "echo \"$ret\";";
}

// associée à eval, 
// génère une variable avec code HTML et subtitution des variables PHP par leur valeur
function htmlVar($unBloc, $uneVar) {
  return "\$$uneVar = \"$unBloc\";";
}

// exemple d'utilisation
/*
//$modele=htmlCharger("test.html"); si fichier externe !
//Remarque : inutile d'échapper le $ dans le fichier externe
$modele="
<html>
  <head><title>Menu</title></head>
  <body>
    <h1>Matin</h1>
    <ul>
      <!--m:itemCompo-->
      <li>\$composant</li>
      <!--m:fin-->
    </ul>
  </body>
</html>";
eval(htmlEcho($modele));
$composants=array("pain", "beurre", "confiture");
foreach($composants as $composant) {
  eval(htmlEcho($modele, "itemCompo"));
}
eval(htmlEcho($modele, "fin"));
*/

?>
